// Generated by CoffeeScript 1.6.3
var bytes, dev, devLogLine, devbw, makeLogger;

bytes = require('bytes');

devLogLine = function(useColor) {
  return function(req, res) {
    var ansi_clear, ansi_color_for_status, ansi_grey, color, len, len_s, line, status;
    status = res.statusCode;
    len = parseInt(res.getHeader('Content-Length'), 10);
    if (status >= 500) {
      color = 31;
    } else if (status >= 400) {
      color = 33;
    } else if (status >= 300) {
      color = 36;
    } else {
      color = 32;
    }
    if (isNaN(len)) {
      len_s = '';
    } else {
      len_s = ' - ' + bytes(len);
    }
    ansi_grey = '\x1b[90m';
    ansi_color_for_status = '\x1b[' + color + 'm';
    ansi_clear = '\x1b[0m';
    line = "";
    if (useColor) {
      line += ansi_grey;
    }
    line += req.method + ' ';
    line += (req.originalUrl || req.url) + ' ';
    if (useColor) {
      line += ansi_color_for_status;
    }
    line += status + ' ';
    if (useColor) {
      line += ansi_grey;
    }
    line += (new Date - req._startTime) + 'ms';
    line += len_s;
    line += ansi_clear;
    return line;
  };
};

makeLogger = function(logfn) {
  var stream;
  stream = process.stdout;
  return function(req, res, next) {
    var logRequest;
    req._startTime = new Date;
    logRequest = function() {
      var line;
      res.removeListener('finish', logRequest);
      res.removeListener('close', logRequest);
      line = logfn(req, res);
      if (line !== null) {
        return stream.write(line + '\n');
      }
    };
    res.on('finish', logRequest);
    res.on('close', logRequest);
    return next();
  };
};

dev = makeLogger(devLogLine(true));

devbw = makeLogger(devLogLine(false));

exports.dev = dev;

exports.devbw = devbw;
